Loading...
Searching...
No Matches
juce::AudioThumbnailCache Class Reference

## Detailed Description

An instance of this class is used to manage multiple AudioThumbnail objects.

The cache runs a single background thread that is shared by all the thumbnails that need it, and it maintains a set of low-res previews in memory, to avoid having to re-scan audio files too often.

See also
  AudioThumbnail

The documentation for this class was generated from the following file:

- juce_audio_utils/gui/juce_AudioThumbnailCache.h

## Public Member Functions

| AudioThumbnailCache (int maxNumThumbsToStore)
| Creates a cache object.
virtual | ~AudioThumbnailCache ()
| Destructor.
void | clear ()
| Clears out any stored thumbnails.
bool | loadThumb (AudioThumbnailBase &thumb, int64 hashCode)
| Reloads the specified thumb if this cache contains the appropriate stored data.
void | storeThumb (const AudioThumbnailBase &thumb, int64 hashCode)
| Stores the cacheable data from the specified thumb in this cache.
void | removeThumb (int64 hashCode)
| Tells the cache to forget about the thumb with the given hashcode.
bool | readFromStream (InputStream &source)
| Attempts to re-load a saved cache of thumbnails from a stream.
void | writeToStream (OutputStream &stream)
| Writes all currently-loaded cache data to a stream.
TimeSliceThread & | getTimeSliceThread () noexcept
| Returns the thread that client thumbnails can use.

## Protected Member Functions

virtual void | saveNewlyFinishedThumbnail (const AudioThumbnailBase &, int64 hashCode)
| This can be overridden to provide a custom callback for saving thumbnails once they have finished being loaded.
virtual bool | loadNewThumb (AudioThumbnailBase &, int64 hashCode)
| This can be overridden to provide a custom callback for loading thumbnails from pre-saved files to save the cache the trouble of having to create them.

## Constructors and Destructors

## AudioThumbnailCache()

juce::AudioThumbnailCache::AudioThumbnailCache | ( | int | maxNumThumbsToStore | ) |

explicit

Creates a cache object.

The maxNumThumbsToStore parameter lets you specify how many previews should be kept in memory at once.

Referenced by loadNewThumb().

## ~AudioThumbnailCache()

virtual juce::AudioThumbnailCache::~AudioThumbnailCache | ( |  | ) |

virtual

Destructor.

## Member Functions

## clear()

void juce::AudioThumbnailCache::clear | ( |  | ) |

Clears out any stored thumbnails.

## loadThumb()

bool juce::AudioThumbnailCache::loadThumb | ( | AudioThumbnailBase & | thumb,
|  | int64 | hashCode )

Reloads the specified thumb if this cache contains the appropriate stored data.

This is called automatically by the AudioThumbnail class, so you shouldn't normally need to call it directly.

## storeThumb()

void juce::AudioThumbnailCache::storeThumb | ( | const AudioThumbnailBase & | thumb,
|  | int64 | hashCode )

Stores the cacheable data from the specified thumb in this cache.

This is called automatically by the AudioThumbnail class, so you shouldn't normally need to call it directly.

## removeThumb()

void juce::AudioThumbnailCache::removeThumb | ( | int64 | hashCode | ) |

Tells the cache to forget about the thumb with the given hashcode.

## readFromStream()

bool juce::AudioThumbnailCache::readFromStream | ( | InputStream & | source | ) |

Attempts to re-load a saved cache of thumbnails from a stream.

The cache data must have been written by the writeToStream() method. This will replace all currently-loaded thumbnails with the new data.

## writeToStream()

void juce::AudioThumbnailCache::writeToStream | ( | OutputStream & | stream | ) |

Writes all currently-loaded cache data to a stream.

The resulting data can be re-loaded with readFromStream().

## getTimeSliceThread()

TimeSliceThread & juce::AudioThumbnailCache::getTimeSliceThread | ( |  | ) |

inline noexcept

Returns the thread that client thumbnails can use.

## saveNewlyFinishedThumbnail()

virtual void juce::AudioThumbnailCache::saveNewlyFinishedThumbnail | ( | const AudioThumbnailBase & | ,
|  | int64 | hashCode )

protected virtual

This can be overridden to provide a custom callback for saving thumbnails once they have finished being loaded.

## loadNewThumb()

virtual bool juce::AudioThumbnailCache::loadNewThumb | ( | AudioThumbnailBase & | ,
|  | int64 | hashCode )

protected virtual

This can be overridden to provide a custom callback for loading thumbnails from pre-saved files to save the cache the trouble of having to create them.

References AudioThumbnailCache().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited